<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_JPCodeSynonym ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_JPCodeSynonym extends AbstractStructArrayBase
{
    /**
     * The JPCodeSynonym
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_JPCodeSynonym[]
     */
    public $JPCodeSynonym;
    /**
     * Constructor method for ArrayOfJP_JPCodeSynonym
     * @uses ArrayOfJP_JPCodeSynonym::setJPCodeSynonym()
     * @param \StructType\JP_JPCodeSynonym[] $jPCodeSynonym
     */
    public function __construct(array $jPCodeSynonym = array())
    {
        $this
            ->setJPCodeSynonym($jPCodeSynonym);
    }
    /**
     * Get JPCodeSynonym value
     * @return \StructType\JP_JPCodeSynonym[]|null
     */
    public function getJPCodeSynonym()
    {
        return $this->JPCodeSynonym;
    }
    /**
     * Set JPCodeSynonym value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_JPCodeSynonym[] $jPCodeSynonym
     * @return \ArrayType\ArrayOfJP_JPCodeSynonym
     */
    public function setJPCodeSynonym(array $jPCodeSynonym = array())
    {
        foreach ($jPCodeSynonym as $arrayOfJP_JPCodeSynonymJPCodeSynonymItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_JPCodeSynonymJPCodeSynonymItem instanceof \StructType\JP_JPCodeSynonym) {
                throw new \InvalidArgumentException(sprintf('The JPCodeSynonym property can only contain items of \StructType\JP_JPCodeSynonym, "%s" given', is_object($arrayOfJP_JPCodeSynonymJPCodeSynonymItem) ? get_class($arrayOfJP_JPCodeSynonymJPCodeSynonymItem) : gettype($arrayOfJP_JPCodeSynonymJPCodeSynonymItem)), __LINE__);
            }
        }
        $this->JPCodeSynonym = $jPCodeSynonym;
        return $this;
    }
    /**
     * Add item to JPCodeSynonym value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_JPCodeSynonym $item
     * @return \ArrayType\ArrayOfJP_JPCodeSynonym
     */
    public function addToJPCodeSynonym(\StructType\JP_JPCodeSynonym $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_JPCodeSynonym) {
            throw new \InvalidArgumentException(sprintf('The JPCodeSynonym property can only contain items of \StructType\JP_JPCodeSynonym, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->JPCodeSynonym[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_JPCodeSynonym|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JPCodeSynonym
     */
    public function getAttributeName()
    {
        return 'JPCodeSynonym';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_JPCodeSynonym
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
